#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>

typedef long long ll;
typedef long double ld;

const int BULAN = 1e6;

int findPeriod(int n) {
  int period = 1;
  int v = 10 % n;
  while (v != 1) {
    v = v * 10 % n;
    period++;
    if (period > BULAN) {
      return -1;
    }
  }
  return period;
}

int main() {
  int a, b;
  ll k;
  int p;
  std::cin >> a >> b >> k >> p;

  int d = std::__gcd(a, b);
  a /= d;
  b /= d;

  std::string s;

  for (int i = 1; i <= BULAN ; i++) {
    int d = a % b;
    a = d * 10;
    s += char(a / b + '0');
  }

  int period = findPeriod(b);
  if (k < BULAN - p) {
    std::cout << s.substr(k - 1, p);
    return 0;
  }
  if (period == -1) {
    std::cout << std::string(p, '0');
    return 0;
  }

  int sz = period;
  k--;
  k %= sz;

  std::cout << s.substr(k, p);

  return 0;
}
